.text
    .org	0x0000
    dc.l	0,RST
    dc.l	INT,INT,INT,INT,INT,INT,INT
    dc.l	INT,INT,INT,INT,INT,INT,INT,INT
    dc.l	INT,INT,INT,INT,INT,INT,INT,INT
    dc.l	INT,INT,INT,HBL,INT,VBL,INT,INT
    dc.l	INT,INT,INT,INT,INT,INT,INT,INT
    dc.l	INT,INT,INT,INT,INT,INT,INT,INT
    dc.l	INT,INT,INT,INT,INT,INT,INT,INT
    dc.l	INT,INT,INT,INT,INT,INT,INT

    .ascii	"SEGA EVERDRIVE  "
    .ascii	"KRIKzz 2012.SEP "
    .ascii	"                                                "
    .ascii	"Mega EverDrive OS                               "
    .ascii	"GM 00000000-00"				    
    dc.w	0x0005
    .ascii	"JD              "				    
    dc.l	global_func
    dc.l	0x00000000
    dc.l	0x00FF0000					    
    dc.l	0x00FFFFFF					    
    .ascii	"B                       "			    
    .ascii	"http://krikzz.com  biokrik@gmail.com    "	    
    .ascii	"F               "

.org 0x200

rom_boot_code:
.global os_init_fpga
os_init_fpga:
    move.w #0x8006, vdp_cnt
    move.w #0x8104, vdp_cnt
    move.w #4095, %d0
    move.l #ram_boot_code, %a0
    move.l #0xff0000, %a1
copy_loader:
    move.l (%a0)+, (%a1)+
    move.l (%a0)+, (%a1)+
    move.l (%a0)+, (%a1)+
    move.l (%a0)+, (%a1)+
    dbra %d0, copy_loader


    move #32767, %d0
    move.w #0x8F02, (vdp_cnt)
    move.l #0x40000000, (vdp_cnt)
    move.l #vdp_dat, %a1
copy_firm_ram_vdp:
    move.w (%a0)+, (%a1)
    dbra %d0, copy_firm_ram_vdp
    move.w #1, 0xff0100 /*force full os loading*/
    jmp 0xff0108

.org 0x400
ram_boot_code:
.incbin "../bootloader/ramboot.bin"
.org 0x8400
.global firm_data
firm_data:
.incbin "../fpga/ed3x.rbf"
.org 0x20400

RST:

    move.w (force_sega_reinit), %d0
    move.w #0, (force_sega_reinit)
    cmp.w #0, %d0
    bne sega_init

    jmp SkipSetup

sega_init:
	lea	Table,%a5
	movem.w (%a5)+,%d5-%d7
	movem.l (%a5)+,%a0-%a4
* Check Version Number
	move.b	-0x10ff(%a1),%d0
	andi.b	#0x0f,%d0
	beq	WrongVersion
* Sega Security Code (SEGA)
	move.l	#0x53454741,0x2f00(%a1)
WrongVersion:
	move.w	(%a4),%d0
	moveq	#0x00,%d0
	movea.l %d0,%a6
	move	%a6,%usp

* Set VDP registers
	moveq	#0x17,%d1
FillLoop:
	move.b	(%a5)+,%d5
	move.w	%d5,(%a4)
	add.w	%d7,%d5
	dbra	%d1,FillLoop

	move.l	(%a5)+,(%a4)
	move.w	%d0,(%a3)
	move.w	%d7,(%a1)
	move.w	%d7,(%a2)
L0250:
	btst	%d0,(%a1)
	bne	L0250
* Put initial values into a00000
	moveq	#0x25,%d2
Filla:
	move.b	(%a5)+,(%a0)+
	dbra	%d2,Filla
	move.w	%d0,(%a2)
	move.w	%d0,(%a1)
	move.w	%d7,(%a2)
L0262:
	move.l	%d0,-(%a6)
	dbra	%d6,L0262
	move.l	(%a5)+,(%a4)
	move.l	(%a5)+,(%a4)
* Put initial values into c00000
	moveq	#0x1f,%d3
Filc0:
	move.l	%d0,(%a3)
	dbra	%d3,Filc0
	move.l	(%a5)+,(%a4)
* Put initial values into c00000
	moveq	#0x13,%d4
Fillc1:
	move.l	%d0,(%a3)
	dbra	%d4,Fillc1
* Put initial values into c00011
	moveq	#0x03,%d5
Fillc2:
	move.b	(%a5)+,0x0011(%a3)
	dbra	%d5,Fillc2
	move.w	%d0,(%a2)
	movem.l (%a6),%d0-%d7/%a0-%a6
	move	#0x2700,%sr
SkipSetup:
	bra	Continue
Table:
	dc.w	0x8000, 0x3fff, 0x0100, 0x00a0, 0x0000, 0x00a1, 0x1100, 0x00a1
	dc.w	0x1200, 0x00c0, 0x0000, 0x00c0, 0x0004, 0x0414, 0x302c, 0x0754
	dc.w	0x0000, 0x0000, 0x0000, 0x812b, 0x0001, 0x0100, 0x00ff, 0xff00
	dc.w	0x0080, 0x4000, 0x0080, 0xaf01, 0xd91f, 0x1127, 0x0021, 0x2600
	dc.w	0xf977, 0xedb0, 0xdde1, 0xfde1, 0xed47, 0xed4f, 0xd1e1, 0xf108
	dc.w	0xd9c1, 0xd1e1, 0xf1f9, 0xf3ed, 0x5636, 0xe9e9, 0x8104, 0x8f01
	dc.w	0xc000, 0x0000, 0x4000, 0x0010, 0x9fbf, 0xdfff



Continue:
    
    move.w #0x8006, 0xC00004
    move.w #0x8104, 0xC00004
    move.l #HBL, 0x70
    move.l #VBL, 0x78

    tst.w 0x00C00004
* set stack pointer
    move.w #0,%a7

* user mode
    move.w #0x2300,%sr

/*
    move.w (cl_ram), %d0
    move.w #0, (cl_ram)
    cmp.w #0, %d0
    beq skip_ram_clean
*/
    move.w #16383, %d0
    move.l #0, %d1
    move.l #0x80000, %a0
cl_os_ram:
    move.l %d1, (%a0)+
    move.l %d1, (%a0)+
    move.l %d1, (%a0)+
    move.l %d1, (%a0)+
    move.l %d1, (%a0)+
    move.l %d1, (%a0)+
    move.l %d1, (%a0)+
    move.l %d1, (%a0)+
    dbra %d0, cl_os_ram


skip_ram_clean:
    jmp main

.equ OS_TMP_BUFF, 0x40000
.equ vdp_dat, 0xC00000
.equ vdp_cnt, 0xC00004




.global os_load_from_sdr
os_load_from_sdr:
    move.l #load_os_from_sdr_code, %a0
    move.l #0xff0000, %a1
    move.w #127, %d0
os_sdr_loop1:
    move.w (%a0)+, (%a1)+
    dbra %d0, os_sdr_loop1
    jmp 0xff0000

load_os_from_sdr_code:
    move.w #0x32ef, (0xA13006)
    move.l #0x100000, %a0
    move.l #0x0, %a1
    move.w #65535, %d0
os_sdr_loop2:
    move.l (%a0)+, (%a1)+
    move.l (%a0)+, (%a1)+
    move.l (%a0)+, (%a1)+
    move.l (%a0)+, (%a1)+
    dbra %d0, os_sdr_loop2
     move.w #0x321f, (0xA13006)
    move.l 0x000004, %a0
    jmp (%a0)

    

.global HBL
HBL:
    
    movem.l %d0-%d1/%a0-%a1,-(%sp)
    jsr hb
    movem.l (%sp)+,%d0-%d1/%a0-%a1
    rte

.global VBL
VBL:
    
    movem.l %d0-%d1/%a0-%a1,-(%sp)
    jsr vb
    movem.l (%sp)+,%d0-%d1/%a0-%a1
    rte

.global INT
INT:
    move.l #0xc0000000, vdp_cnt
    move.w #0xF0F, vdp_dat
forever:
    jmp forever
    movem.l %d0-%d1/%a0-%a1,-(%sp)
    jsr in
    movem.l (%sp)+,%d0-%d1/%a0-%a1
    rte


.align 4
global_func:
    dc.l diskWrite
    dc.l diskRead
    dc.l usbReadByte
    dc.l usbWriteByte
    dc.l usbReadDma
    dc.l usbReadPio
    dc.l usbRdReady
    dc.l usbWrReady
    dc.l osSetMemMap
    dc.l osGetOsVersion
    dc.l osGetFirmVersion
    dc.l osGetSerial
    dc.l VDP_setReg
    dc.l VDP_vintOn
    dc.l VDP_vintOff
    dc.l memInitDmaCode
    dc.l osReadDir
    dc.l fatOpenDir
    dc.l fatOpenFileByeName
    dc.l fatOpenFile
    dc.l fatReadFile
    dc.l fatWriteFile
    dc.l fatCreateRecIfNotExist
    dc.l fatSkipSectors

*lib v2
    dc.l fatSetCurrentFile
    dc.l fatGetCurrentFile
    dc.l osWavPlayerUpdate
    dc.l osWavPlayerStop
    dc.l usbRead
    dc.l usbWrite
    dc.l osSocketConnect
    dc.l osSocketClose
    dc.l osSocketWrite
    dc.l osSocketRead

.align 4
.global font
font:
.incbin "gfx/font.bin"

.align 4
.global gfx
gfx:
.incbin "gfx/gfx.gif-pix.bin"

.align 4
.global need_backup
need_backup:
    dc.w 0

.align 4
.global force_sega_reinit
force_sega_reinit:
    dc.w 0
