/* 
 * File:   everdrive.h
 * Author: krik
 *
 * Created on 29  2011 ., 7:02
 */

#ifndef _EVERDRIVE_H
#define	_EVERDRIVE_H




#define DMA_RAM 0
#define DMA_SPI 1
#define DMA_USB 2



#define _SPI_SS 0
#define _SPI_FULL_SPEED 1
#define _SPI_SPI16 2
#define _SPI_AREAD 3
#define _SPI_DISK 4

#define _STATE_SPI_READY 0
#define _STATE_FIFO_WR_READY 1
#define _STATE_FIFO_RD_READY 2


#define SPI_PORT *((volatile u16*) (0xA13000))
#define SPI_CFG_PORT *((volatile u16*) (0xA13002))
//#define ROM_CFG_PORT *((volatile u16*) (0xA13004))
#define REG_MAP_PORT *((volatile u16*) (0xA13006))
#define REG_FIRM *((volatile u16*) (0xA13008))
#define FIFO_PORT *((volatile u16*) (0xA1300A))
#define STATE_PORT *((volatile u16*) (0xA1300C))
#define REG_DAC *((volatile u16*) (0xA1300E))
#define REG_MAPPER *((volatile u16*) (0xA13010))
#define REG_BANK_SRC *((volatile u16*) (0xA13012))
#define REG_DMA_ADDR *((volatile u16*) (0xA13014))
#define REG_DMA_LEN *((volatile u16*) (0xA13018))
#define REG_DMA_CFG *((volatile u16*) (0xA1301a))
#define REG_MKEY_CFG *((volatile u16*) (0xA1301e))
#define REG_DAC_CFG *((volatile u16*) (0xA13020))

#define REG_SPD *((volatile u16*) (0xA13028))



#define SPI_SPEED_INIT 0
#define SPI_SPEED_25 1
#define SPI_SPEED_50 2

#define SPI16_ON SPI_CFG_PORT |= (1 << _SPI_SPI16)
#define SPI16_OFF SPI_CFG_PORT &= ~(1 << _SPI_SPI16)
#define SPI_AR_ON SPI_CFG_PORT |= (1 << _SPI_AREAD)
#define SPI_AR_OFF SPI_CFG_PORT &= ~(1 << _SPI_AREAD)
#define SPI_SS_OFF SPI_CFG_PORT |= (1 << _SPI_SS)
#define SPI_SS_ON SPI_CFG_PORT &= ~(1 << _SPI_SS)
#define SPI_HI_SPEED_ON SPI_CFG_PORT |= (1 << _SPI_FULL_SPEED)
#define SPI_HI_SPEED_OFF SPI_CFG_PORT &= ~(1 << _SPI_FULL_SPEED)

#define FIFO_RST_ON SPI_CFG_PORT |= (1 << 6)
#define FIFO_RST_OFF SPI_CFG_PORT &= ~(1 << 6)

#define IS_SPI_READY (STATE_PORT & (1 << _STATE_SPI_READY))
#define SPI_BUSY while(!IS_SPI_READY)

#define IS_FIFO_RD_READY (STATE_PORT & (1 << _STATE_FIFO_RD_READY))
#define IS_FIFO_WR_READY (STATE_PORT & (1 << _STATE_FIFO_WR_READY))
#define FIFO_RD_BUSY while(!IS_FIFO_RD_READY)
#define FIFO_WR_BUSY while(!IS_FIFO_WR_READY)
#define SET_ROM_BANK(frame, bank) (REG_MAP_PORT = (REG_MAP_PORT & ~(15 << frame*4)) | (bank << frame*4))


#define MTYPE_OS 0
#define MTYPE_MD 1
#define MTYPE_SSF 2
#define MTYPE_CD 3
#define MTYPE_SMS 4
#define MTYPE_10M 5
#define MTYPE_32X 6


#define MD_SUB_SRAM_OFF 0
#define MD_SUB_SRAM_ON 1
#define MD_SUB_SRAM_3M_ON 2
#define MD_SUB_SNAP_SAVE_ON 4
#define MD_SUB_MKEY 8

#define SMS_SUB_STD 1
#define SMS_SUB_CDM 2
#define SMS_SUB_KOR 4
#define SMS_SUB_ALL 7

#define CD_SUB_NAT_BIOS 1



#endif	/* _EVERDRIVE_H */

