/* 
 * File:   graphics.h
 * Author: krik
 *
 * Created on 29  2011 ., 3:38
 */

#ifndef _GRAPHICS_H
#define	_GRAPHICS_H

typedef struct {
    u16 addr;
    u8 w;
    u8 h;
} Image;

void gRepaint();
void gDrawString(u8 *str, u8 x, u8 y);
void gCleanPlan(u8 clr_a, u8 clr_b);
void gSelectPlan(u16 p);
void gAppendString(u8 *str);
void gAppendNum(u32 num);
void gAppendHex32(u32 num);
void gAppendHex16(u16 num);
void gAppendHex8(u8 num);
void gAppendNumFlen(u32 num, u8 min_len);
void gSelectPalette(u16 pal);
void gFillRect(u16 tile, u8 x, u8 y, u8 w, u8 h);
Image* gLoadImage(void *tiledata, u8 w, u8 h);
void gDrawImage(Image *img, u8 x, u8 y);
void gLoadImageTo(void *tiledata, u8 w, u8 h, u16 idx_addr);
void gConsDrawString(u8 *str);
void gConsInit();
void gDrawStringCn(u8 *str, u8 y);
void gDrawNumFlen(u16 num, u8 flen, u8 x, u8 y);
void gLockRepaint(u8 state);
void gDrawNum(u16 num, u8 x, u8 y);
void gDrawHex32(u32 num, u8 x, u8 y);
void gDrawBin8(u16 num, u8 x, u8 y);
void gAppendBin8(u16 num);
void gDrawHex16(u16 num, u8 x, u8 y);
void gInit();
void gDrawNum(u16 num, u8 x, u8 y);
void gConsDrawStrNum(u8 *str, u32 num);
u16 gGetCurrentPalette();
u16 gGetCurrentPlan();
void gBackupScreen();
void gRepairScreen();
void gDrawStringMaxLen(u8 *str, u8 x, u8 y, u16 len);
void gAppendChar(u8 chr);
u16 gGetRepaintState();
void gFillRectInc(u16 tile, u8 x, u8 y, u8 w, u8 h);

#endif	/* _GRAPHICS_H */

