/* 
 * File:   gui.h
 * Author: krik
 *
 * Created on 18  2011 ., 19:05
 */

#ifndef _GUI_H
#define	_GUI_H

#include "fat.h"
#include "types.h"


typedef struct {
    s16 selector;
    u8 **items_names;
    u8 *menu_name;
    u8 items_num;
} ListForm;

typedef struct {
    s16 selector;
    u8 icons[16];
    u8 **items_names;
    u8 *menu_name;
    u8 items_num;
    u8 return_av;
} IconForm;

enum {
    ICON_PLAY = 0,
    ICON_SD,
    ICON_MSD,
    ICON_CHETS,
    ICON_CD,
    ICON_CFG,
    ICON_SYS,
    ICON_TEST,
    ICON_ABOUT
};

#define SEL_CMD_NOP 0
#define SEL_CMD_START_OLD 1
#define SEL_CMD_MENU 2
#define SEL_CMD_FILE_MENU 3


u8 iconFormShow(IconForm *form);
u8 selectFile(FatFullRecord **rec, u16 *cmd, u16 init);
u16 options();
u16 guiListForm(ListForm *form);
void guiShowMessage(u8 *title, u8 *txt);
void guiDrawWin(u8 *title, u16 x, u16 y, u16 w, u16 h);
void guiDeviceInfo();
void guiAbout();
void guiDrawCursor(u8 *str, u16 x, u16 y);
u16 guiHexView(FatFullRecord *rec);

#define COLOR_SEL 0xfff
#define COLOR_UNSEL 0x0ff

extern u8 dir_name_begin[4];

#endif	/* _GUI_H */

