
.equ joy1, 0xa10003
.equ joy2, 0xa10005
.equ vdp_dat, 0xC00000
.equ vdp_cnt, 0xC00004
.equ key_reg, 0xA13040
.equ snap_data, 0x180000
.equ sram_data, 0x100000
.equ vdp_regs_mirror, 0x1FFFC0


.align 16

.global ingame_menu_code
ingame_menu_code:
.ascii "SEGA"

.org 0x04
skip_vbl:
    move.w #0, (key_reg)
    rte

game_vbl:
    jmp 0x114.l
.org 0x14
    move.w #0, (key_reg)
.global ingame_game_vbl
ingame_game_vbl:
    jmp 0x1234AABB.l

.org  0x22
ingame_menu_vb:

    movem.l %d0-%d1/%a0, -(%a7)
    move.l #joy1, %a0
    move.b (%a0), %d0
    

ingame_joy_check:
    move.b (%a0), %d0
    move.b #0, (%a0)
rd_joy_0:
    btst.b #5, (%a0)
    bne back_joy_state1

    btst.b #1, (%a0)
    bne back_joy_state1


    move.w (0xA11100), %d1
    move.w #0x100, (0xA11100)
    move.w #0x1234, (key_reg)
    jmp save_state.l

    
back_joy_state1:
    move.w #6, %d1
    btst.b #6, %d0
    beq return_to_game_vbl
joy_rst:
    eor.b #0x40, (%a0)
    nop
    dbra %d1, joy_rst
    

return_to_game_vbl:
    movem.l (%a7)+, %d0-%d1/%a0
    jmp game_vbl

.org 0x80
save_state:
    and.w #0x100, %d1
    eor.w #0x100, %d1
    move.w %d1, (halt_state)
    movem.l (%a7)+, %d0-%d1/%a0

    move.w #0x810c, (vdp_cnt)

    *save registers
    move.l %a0, (snap_data)
    move.l #snap_data + 0x40, %a0
    movem.l %a1-%a7/%d0-%d7, -(%a0)


    move.l #snap_data + 0x40, %a1

    move.w #23, %d0
    move.l #vdp_regs_mirror, %a0
vdp_regs_save:
    move.w (%a0)+, (%a1)+
    dbra %d0, vdp_regs_save

    

    move.w #4095, %d0
    move.l #0xff0000, %a0
ram_save:
    move.l (%a0)+, (%a1)+
    move.l (%a0)+, (%a1)+
    move.l (%a0)+, (%a1)+
    move.l (%a0)+, (%a1)+
    dbra %d0, ram_save

    move.w #2047, %d0
    move.l #sram_data, %a0
sram_save:
    move.l (%a0)+, (%a1)+
    move.l (%a0)+, (%a1)+
    move.l (%a0)+, (%a1)+
    move.l (%a0)+, (%a1)+
    dbra %d0, sram_save

    move.w #0x8F02, (vdp_cnt)
    move.w #32767, %d0
    move.l #vdp_dat, %a0
    move.l #0, (vdp_cnt)
vram_save:
    move.w (%a0), (%a1)+
    dbra %d0, vram_save

    move.w #63, %d0
    move.l #0x20, (vdp_cnt)
cram_save:
    move.w (%a0), (%a1)+
    dbra %d0, cram_save

    move.w #39, %d0
    move.l #0x10, (vdp_cnt)
vsram_save:
    move.w (%a0), (%a1)+
    dbra %d0, vsram_save


    move.w (halt_state), (%a1)+
    move.b (joy1_state), (%a1)+
    move.b (joy2), (%a1)+

    *move.w #0x0100, 0xA11200
    move.w #8191, %d0
    move.l #0xA00000, %a0
z80_save:
    move.b (%a0)+, (%a1)+
    dbra %d0, z80_save

    move.l #snap_data + 0x04, %a0
    movem.l (%a0)+, %a1-%a7/%d0-%d7
    move.l (snap_data), %a0


    move.w (snap_data + 0x42), (vdp_cnt)

    jmp osIngameMenu



.global restore_state
restore_state:
    move.w #0x810c, (vdp_cnt)
    move.w #0x100, (0xA11100)


    move.l #snap_data + 0x40, %a0
    move.w #23, %d0
    move.l #vdp_regs_mirror, %a1
vdp_regs_mirror_restore:
    move.w (%a0)+, (%a1)+
    dbra %d0, vdp_regs_mirror_restore

    move.l #vdp_regs_mirror, %a2
    move.l #snap_data + 0x44, %a0
    move.w #16, %d0
    move.l #vdp_cnt, %a1
vdp_regs_restore:
    nop
    nop
    nop
    nop
    move.w (%a0), %d1
    and.w #0xE000, %d1
    cmp.w #0x8000, %d1
    bne skip_vdp_reg
    move.w (%a0), (%a1)
skip_vdp_reg:
    add.l #2, %a0
    dbra %d0, vdp_regs_restore


    move.l #snap_data + 0x70, %a0
    move.w #4095, %d0
    move.l #0xff0000, %a1
ram_restore:
    move.l (%a0)+, (%a1)+
    move.l (%a0)+, (%a1)+
    move.l (%a0)+, (%a1)+
    move.l (%a0)+, (%a1)+
    dbra %d0, ram_restore

    move.w #2047, %d0
    move.l #sram_data, %a1
sram_restore:
    move.l (%a0)+, (%a1)+
    move.l (%a0)+, (%a1)+
    move.l (%a0)+, (%a1)+
    move.l (%a0)+, (%a1)+
    dbra %d0, sram_restore

    move.w #0x8F02, (vdp_cnt)
    move.w #32767, %d0
    move.l #vdp_dat, %a1
    move.l #0x40000000, (vdp_cnt)
vram_restore:
    move.w (%a0)+, (%a1)
    dbra %d0, vram_restore

    move.w #63, %d0
    move.l #0xc0000000, (vdp_cnt)
cram_restore:
    move.w (%a0)+, (%a1)
    dbra %d0, cram_restore


    move.w #39, %d0
    move.l #0x40000010, (vdp_cnt)
vsram_restore:
    move.w (%a0)+, (%a1)
    dbra %d0, vsram_restore


    move.l #snap_data + 0x04, %a0
    movem.l (%a0)+, %a1-%a7/%d0-%d7
    move.l (snap_data), %a0

    move.w (halt_state), (0xA11100)
    move.w (snap_data + 0x40), (vdp_cnt)
    move.w (snap_data + 0x5e), (vdp_cnt)
    move.w (snap_data + 0x42), (vdp_cnt)

    jmp 0x104.l

.align 2

joy1_state:
.dc.b 0
joy2_state:
.dc.b 0
halt_state:
.dc.w 0

