/*
 * File:   main.c
 * Author: krikzz
 *
 * Created on 23.06.2010
 */



#include "sega.h"
#include "disk.h"
#include "gui.h"
#include "fat.h"
#include "mem.h"
#include "everdrive.h"
#include "usb.h"
#include "graphics.h"
#include "string.h"
#include "rom.h"
#include "gg.h"




u32 fifo_addr;

void fifo_load(u32 addr, u16 len);
u8 startGame(u8 mapper);
void run_dma(u16 arg);
void drawError(u8 *comment, u32 code);
u16 loadGame(FatRecord *rec, u16 new_game);
u16 cdTools();
u16 cdSetBios();
u16 cdRunCustomBios();
u16 cdCopyRamToSd();
IconForm icon_form;
u16 fileMenu(FatFullRecord *rec);
u16 mainMenu();


u8 cy;


/*
enum {
    MAIN_MENU_PLAY = 0,
    MAIN_MENU_SD,
    MAIN_MENU_MSD,
    MAIN_MENU_CHEATS,
    MAIN_MENU_CD,
    MAIN_MENU_GCFG,
    MAIN_MENU_SYS_INF,
    MAIN_MENU_ABOUT,
    MAIN_MENU_LEN
};*/

//u8 *main_menu_iname[MAIN_MENU_LEN];

u32 mem_test();

int main() {


    FatFullRecord *rec = 0;
    //FatRecord rec_obj;
    u16 resp;

    u16 cmd;
    u16 init_browser;
    u8 ext[8];


    // u8 buff[1024];


    //osPlayWav(0);

    resp = osInit();




    if (resp) {
        drawError("OS init error", resp);
        for (;;);
    }
    gConsDrawString("init done!");

    /*
    u32 ii = 0;
    for (;;) {

        ii += usbWrite(buff, 1024, 0x20000);
        gConsDrawStrNum("ctr: ", ii);

    }*/

    //JOY_waitAct();
    /*
    fatOpenDir(0);
    FatFullRecord frec;


    for (;;) {

        osReadDir(&frec);
        gConsDrawString(frec.name);
        if (frec.entry_cluster == 0)break;
    }

    JOY_waitAct();*/
    /*
    u16 i;
    u32 tot;
    u8 zok = 0;
     */
    for (;;) {

        init_browser = 1;

        for (;;) {

            resp = selectFile(&rec, &cmd, init_browser);

            while (joy != 0);
            if (resp)break;




            switch (cmd) {
                case SEL_CMD_START_OLD:

                    if (os_cfg->gam_cfg.rec.entry_cluster == 0) {
                        init_browser = 0;
                        break;
                    }
                    resp = osLoadRom();
                    if (resp == 0) {
                        osStartRom();
                    }
                    break;
                    /*
                case SEL_CMD_START_NEW:
                    resp = loadGame(rec, 1);
                    break;*/
                case SEL_CMD_FILE_MENU:

                    fatGetRecExt(rec, ext);
                    //fatGetFileExt(rec, ext);

                    if (strEq("cst", ext)) {
                        resp = osInstallCustomizator(rec);
                    } else if (strEq("wav", ext) || strEq("tfc", ext) || strEq("gym", ext)) {
                        resp = osPlaySound(rec, ext);
                    } else {
                        resp = fileMenu(rec);
                    }
                    init_browser = 0;
                    break;

                case SEL_CMD_MENU:

                    resp = mainMenu();
                    init_browser = 0;
                    break;
            }




            if (resp) {

                break;
            }
        }

        VDP_vintOn();
        gLockRepaint(0);
        drawError("error", resp);
        //?VDP_fillTileRect()

    }
    /*

        for (;;) {


            // MEM32(1) = 88;
            gLockRepaint(0);
            iconFormShow(&icon_form);
            rec = 0;


            switch (icon_form.selector) {

                case MAIN_MENU_PLAY:
                    resp = loadGame(0, 0, 0);
                    VDP_vintOn();
                    if (resp)drawError("loading error: ", resp);
                    break;

                case MAIN_MENU_SD:
                    fatSelectDisk(DISK_SD);
                    //selectFile(&rec, 0);
                    resp = loadGame(rec, 1, DISK_SD);
                    VDP_vintOn();
                    if (resp)drawError("loading error: ", resp);
                    break;
                case MAIN_MENU_MSD:
                    fatSelectDisk(DISK_MSD);
                    //selectFile(&rec, 0);
                    resp = loadGame(rec, 1, DISK_MSD);
                    VDP_vintOn();
                    if (resp)drawError("loading error: ", resp);
                    break;
                case MAIN_MENU_GCFG:
                    options();
                    break;
                case MAIN_MENU_CD:
                    resp = cdTools();
                    if (resp)drawError("error: ", resp);
                    break;
            }


        }*/


    return 0;
}

enum {
    FILE_SEL_START = 0,
    FILE_SEL_ONLY,
    FILE_HEX,
    FILE_MENU_LEN
};

enum {
    SS_VIEW = 0,
    SS_LOAD,
    SS_HEX,
    SS_LEN
};

#define MENU_TYPE_FILE 0
#define MENU_TYPE_SS 10

u16 fileMenu(FatFullRecord *rec) {

    u8 menu_type;
    u16 resp;
    static u8 * item_names[] = {"Select and start", "Select only", "Hex view"};
    static u8 * ss_names[] = {"Preview", "Load game", "Hex view"};

    ListForm form;
    form.menu_name = "File menu";
    form.selector = 0;


    if (rec->size == SAVE_LEN_SNAP && strEqL(dir_name_begin, "SNAP", 4)) {
        menu_type = MENU_TYPE_SS;
    } else {
        menu_type = MENU_TYPE_FILE;
    }

    if (menu_type == MENU_TYPE_SS) {
        form.items_names = ss_names;
        form.items_num = SS_LEN;
    } else {
        form.items_names = item_names;
        form.items_num = FILE_MENU_LEN;
    }

    gBackupScreen();
    resp = guiListForm(&form);
    while (joy != 0);

    gRepairScreen();

    resp += menu_type;

    switch (resp) {

        case FILE_SEL_START + MENU_TYPE_FILE:
            resp = osSelectGame(rec);
            if (resp)return resp;
            resp = osLoadRom();
            if (resp)return resp;
            osStartRom();
            break;
        case FILE_SEL_ONLY + MENU_TYPE_FILE:
            resp = 0;
            guiShowMessage("file menu", "wait...");
            resp = osSelectGame(rec);
            if (resp)return resp;
            gRepairScreen();
            break;

        case FILE_HEX + MENU_TYPE_FILE:
        case SS_HEX + MENU_TYPE_SS:
            resp = guiHexView(rec);
            if (resp)return resp;
            gRepairScreen();
            break;


        case SS_VIEW + MENU_TYPE_SS:
            resp = osShowSnap(rec);
            if (resp)return resp;
            gRepairScreen();
            break;

        case SS_LOAD + MENU_TYPE_SS:
            resp = osLoadSaveState(rec);
            if (resp)return resp;
            gRepairScreen();
            break;

        default:
            return 0;
    }

    return 0;
}

enum {
    MAIN_MENU_OPTIONS = 0,
    MAIN_MENU_CHEATS,
    MAIN_MENU_RUN_CD,
    MAIN_MENU_DEV_INFO,
    MAIN_MENU_ABOUT,
    MAIN_MENU_LEN
};

u16 mainMenu() {

    u16 resp;
    static u8 * item_names[] = {"Options", "Cheats", "Run CD", "System Info", "About"};
    ListForm form;
    form.menu_name = "Main Menu";
    form.selector = 0;
    form.items_names = item_names;
    form.items_num = MAIN_MENU_LEN;

    gBackupScreen();

    for (;;) {


        gRepairScreen();

        resp = guiListForm(&form);

        gRepairScreen();


        switch (resp) {

            case MAIN_MENU_OPTIONS:
                resp = options();
                if (resp)return resp;
                break;
            case MAIN_MENU_CHEATS:
                resp = ggChets();
                if (resp)return resp;
                break;
            case MAIN_MENU_DEV_INFO:
                guiDeviceInfo();
                break;
            case MAIN_MENU_ABOUT:
                guiAbout();
                break;
            case MAIN_MENU_RUN_CD:
                if (dev_info.cd_region == CD_NOT_PRESENT) {
                    guiShowMessage("Warning", "CD add-on is not detected");
                    while (joy != 0);
                    while (joy == 0);

                } else {
                    resp = osRunNativeCD();
                    if (resp)return resp;
                }
                break;

            case 0xffff:
                return 0;
        }
    }

    return 0;
}

void drawError(u8 *comment, u32 code) {

    u8 str_buff[32];
    u16 str_ptr = 0;
    u8 *err_msg = 0;

    gCleanPlan(1, 1);

    if (!VDP_vinIsEnabled()) {
        gConsDrawString("warning: vint is off");
        VDP_vintOn();
    }



    err_msg = "error: ";

    if (code >= FAT_ERR_EXIST && code < 120) {
        err_msg = "fat error: ";
    } else if (code >= DISK_ERR_INIT && code < 62) {
        err_msg = "disk init error: ";
    } else if (code >= DISK_ERR_RD1 && code <= DISK_ERR_RD2) {
        err_msg = "disk read error: ";
    } else if (code >= DISK_ERR_WR1 && code <= DISK_ERR_WR5) {
        err_msg = "disk write error: ";
    } else {

        switch (code) {
            case FAT_ERR_NOT_EXIST:
                err_msg = "file not exist: ";
                break;
            case ERR_BAD_DMA_ADDRESS:
                err_msg = "bad dma ddress: ";
                break;
            case MEM_ERR_SPI_RD_TIMEOUT:
                err_msg = "spi timeout: ";
                break;
            case ERR_FILE_TOO_BIG:
                err_msg = "file too big: ";
                break;
        }

    }
    /*
    switch(code){


    }*/
    str_ptr = strCopy(err_msg, &str_buff[str_ptr]);

    str_buff[str_ptr++] = '0' + code % 1000 / 100;
    str_buff[str_ptr++] = '0' + code % 100 / 10;
    str_buff[str_ptr++] = '0' + code % 10 / 1;
    str_buff[str_ptr++] = 0;

    guiShowMessage(comment, str_buff);

    while (joy != 0);
    while (joy == 0);
    while (joy != 0);

}

void vb() {


    if (VDP_dmaIsComplete()) {
        gRepaint();
        usbListener();
    }

    timer++;
    joy = JOY_readJoypad(JOY_1);



    vb_ctr++;
    
    osStartRomIN1();
}

void hb() {
    //hblank interrupt
}

void in() {
    //all other interrupts
}


