

#ifndef _MEM_H
#define	_MEM_H

#include "types.h"

typedef struct {
    u32 app_dst_addr;
    u32 app_map_cfg;
    u32 loader_src;
    u32 firm_src;
    u32 firm_len;
    u8 app_name[108];
} RebootCfg;

#define MEM32(addr)*((volatile u32*) (addr))
#define MEM16(addr)*((volatile u16*) (addr))
#define MEM8(addr)*((volatile u8*) (addr))

void memtst();
void mem_read_sd_block(void *dst);
u8 mem_wait_fe();
u8 mem_spi(u8 dat);
void memSpiSSOn();
void memSpiSSOff();
void memSpiBusy();
u8 memSpiIsBusy();
void memSpiSetSpeed(u8 speed);
void spiReadBlock(void *dat);
void spiWriteBlock(void *dat);
u8 memSpiRead(void *dst, u16 slen);
void memfill(void *dst, u8 val, u32 len);
void memcopy(void *src, void *dst, u32 len);
u8 memSpiWrite(void *src);
void mem_cpy8(void *stc, void *dst, u32 len);
void mem_cpy16(void *stc, void *dst, u32 len);
void mem_cpy32(void *stc, void *dst, u32 len);
void memInit();
void mem_fill_32(u32 val, u32 *addr, u16 len);
void mem_fill_16(u16 val, u16 *addr, u16 len);
void mem_copy_to_reg32(u32 *src, u32 dst, u16 len);
void mem_copy_to_reg16(u16 *src, u32 dst, u16 len);
void run_dma(u16 arg);
void mem_fill_inc_16(u16 val, u16 *addr, u16 len);
void memRebootOS(void *firm_addr, u32 firm_len);
void *memAllocate(u32 size, u16 align);
u32 memRamUsed();
u16 memEq(void *src1, void *src2, u32 len);
u16 memIsEmpty(u32 val, void *addr, u32 len);

#endif	/* _MEM_H */
