

.equ spi_port,  0xA13000
.equ spi_cfg_port,  0xA13002
.equ fifo_port,  0xA1300A
.equ state_port,  0xA1300C

.equ dma_addr_port, 0xA13014
.equ dma_len_port, 0xA13018
.equ dma_src_port, 0xA1301a

.macro ldp  pidx, reg, ris
    move.l (4 + \pidx * 4 + \ris * 4)(%sp), \reg
.endm

.global memtst
memtst:
    
    move.l #0, %a0
    move.l #4, %a1
    move.w #8191, %d1

loop_in:
    move.w #15, %d0
loop:
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+

    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    dbra %d0, loop
    dbra %d1, loop_in
    rts


.global mem_ram_to_spi
 mem_ram_to_spi:
    movem.l %d0-%d3/%a0-%a3, -(%sp)
    ldp 0, %a0, 8
    move.l #0xA13000, %a1
    move.w #15, %d0

wr_sdb_loop:

    move.w (%a0)+, (%a1)
    move.w (%a0)+, (%a1)
    move.w (%a0)+, (%a1)
    move.w (%a0)+, (%a1)
    move.w (%a0)+, (%a1)
    move.w (%a0)+, (%a1)
    move.w (%a0)+, (%a1)
    move.w (%a0)+, (%a1)

    move.w (%a0)+, (%a1)
    move.w (%a0)+, (%a1)
    move.w (%a0)+, (%a1)
    move.w (%a0)+, (%a1)
    move.w (%a0)+, (%a1)
    move.w (%a0)+, (%a1)
    move.w (%a0)+, (%a1)
    move.w (%a0)+, (%a1)

    dbra %d0, wr_sdb_loop
    movem.l (%sp)+, %d0-%d3/%a0-%a3
    rts


.global mem_spi_to_ram
mem_spi_to_ram:
    movem.l %d0-%d3/%a0-%a3, -(%sp)
    ldp 0, %a1, 8
    move.l #0xA13000, %a0
    move.w #15, %d0
    move.w (%a0), (%a1)
    
rd_sdb_loop:

    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+

    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+
    move.w (%a0), (%a1)+

    dbra %d0, rd_sdb_loop
    movem.l (%sp)+, %d0-%d3/%a0-%a3
    rts




.global mem_spi
mem_spi:
    move.w 6(%sp), (spi_port)
wt_spi:
    move.w (state_port), %d0
    btst #0, %d0
    beq.s wt_spi
    move.w (spi_port), %d0
    rts


.global fifo_read
fifo_read:
    movem.l %d0-%d3/%a0-%a3, -(%sp)
    ldp 0, %a0, 8
    ldp 1, %d0, 8
    subq.w #1, %d0
    move.l #state_port, %a1
    move.l #fifo_port, %a2
rep_loop:
    move.w #255, %d1
fifo_loop1:
    move.w (%a1), %d2
    btst #2, %d2
    beq.s fifo_loop1
    move.w (%a2), %d2
fifo_loop2:
    move.w (%a1), %d2
    btst #2, %d2
    beq.s fifo_loop2
    move.w (%a2), (%a0)+


    dbra %d1, fifo_loop1
    dbra %d0, rep_loop

    movem.l (%sp)+, %d0-%d3/%a0-%a3
    rts



.global run_dma
run_dma:
    movem.l %d1, -(%sp)  
    ldp 0, %d1, 1
    jsr 0xff0000
    movem.l (%sp)+, %d1
    rts


.global mem_dma_code
mem_dma_code:
    move.w %d1, (dma_src_port)
mem_dma_wait:
    move.w (state_port), %d1
    btst #3, %d1
    beq.s mem_dma_wait
    rts
.org mem_dma_code + 32

.global mem_cpy32
mem_cpy32:
    movem.l %d0/%a0-%a1, -(%sp)
    ldp 0, %a0, 3
    ldp 1, %a1, 3
    ldp 2, %d0, 3
    sub.l #1, %d0
cpy32_loop:
    move.l (%a0)+, (%a1)+
    dbra %d0, cpy32_loop
    movem.l (%sp)+, %d0/%a0-%a1
    rts


.global mem_cpy16
mem_cpy16:
    movem.l %d0/%a0-%a1, -(%sp)
    ldp 0, %a0, 3
    ldp 1, %a1, 3
    ldp 2, %d0, 3
    sub.l #1, %d0
cpy16_loop:
    move.w (%a0)+, (%a1)+
    dbra %d0, cpy16_loop
    movem.l (%sp)+, %d0/%a0-%a1
    rts


.global mem_cpy8
mem_cpy8:
    movem.l %d0/%a0-%a1, -(%sp)
    ldp 0, %a0, 3
    ldp 1, %a1, 3
    ldp 2, %d0, 3
    sub.l #1, %d0
cpy8_loop:
    move.b (%a0)+, (%a1)+
    dbra %d0, cpy8_loop
    movem.l (%sp)+, %d0/%a0-%a1
    rts


.global mem_wait_fe
mem_wait_fe:
    movem.l %d1, -(%sp)
    move.w #32767, %d1
wfe_loop:
    move.w #0xffff, (spi_port)
    move.w (spi_port), %d0
    cmp.b #0xfe, %d0
    beq wfe_end
    dbra %d1, wfe_loop

wfe_end:
    movem.l (%sp)+, %d1
    rts






.global mem_fill_32
mem_fill_32:
    movem.l %d0-%d1/%a0, -(%sp)
    ldp 0, %d0, 3
    ldp 1, %a0, 3
    ldp 2, %d1, 3
    subq.w #1, %d1
fill32:
    move.l %d0, (%a0)+
    dbra %d1, fill32
    movem.l (%sp)+, %d0-%d1/%a0
    rts



.global mem_fill_16
mem_fill_16:
    movem.l %d0-%d1/%a0, -(%sp)
    ldp 0, %d0, 3
    ldp 1, %a0, 3
    ldp 2, %d1, 3
    subq.w #1, %d1
fill16:
    move.w %d0, (%a0)+
    dbra %d1, fill16
    movem.l (%sp)+, %d0-%d1/%a0
    rts

.global mem_copy_to_reg32
mem_copy_to_reg32:
    movem.l %d0/%a0-%a1, -(%sp)
    ldp 0, %a0, 3
    ldp 1, %a1, 3
    ldp 2, %d0, 3
    subq.w #1, %d0
mtr32:
    move.l (%a0)+, (%a1)
    dbra %d0, mtr32
    movem.l (%sp)+, %d0/%a0-%a1
    rts

.global mem_copy_to_reg16
mem_copy_to_reg16:
    movem.l %d0/%a0-%a1, -(%sp)
    ldp 0, %a0, 3
    ldp 1, %a1, 3
    ldp 2, %d0, 3
    subq.w #1, %d0
mtr16:
    move.w (%a0)+, (%a1)
    dbra %d0, mtr16
    movem.l (%sp)+, %d0/%a0-%a1
    rts

.global mem_fill_inc_16
mem_fill_inc_16:
    movem.l %d0-%d1/%a0, -(%sp)
    ldp 0, %d0, 3
    ldp 1, %a0, 3
    ldp 2, %d1, 3
    subq.w #1, %d1
fill_inc_16:
    move.w %d0, (%a0)+
    addq.w #1, %d0
    dbra %d1, fill_inc_16
    movem.l (%sp)+, %d0-%d1/%a0
    rts






.global mem_spi_dma
mem_spi_dma:

    movem.l %d0-%d2/%a0, -(%sp)
    ldp 0, %d1, 4
    ldp 1, %d0, 4
    subq.w #1, %d0
    lsr.l #8, %d1
    lsr.l #1, %d1
    move.w %d1, %a0
    move.w #1, (dma_len_port)

spi_to_rom_loop:
    move.w #32767, %d1
wfe:
    move.w #0xffff, (spi_port)
    move.w (spi_port), %d2
    cmp.b #0xfe, %d2
    beq wfe_ok
    dbra %d1, wfe
wfe_timeout:
    movem.l (%sp)+, %d0-%d2/%a0
    move.l #1, %d0
    rts
wfe_ok:
    or.w #0x0c, (spi_cfg_port)
    move.w (spi_port), %d2
    move.w %a0, (dma_addr_port)
    move.w #1, %d1
    jsr 0xff0000

    add.w #1, %a0

    and.w #~0x0c, (spi_cfg_port)
    dbra %d0, spi_to_rom_loop

    movem.l (%sp)+, %d0-%d2/%a0
    move.l #0, %d0
    rts


.global mem_is_empty
mem_is_empty:
    movem.l %d1-%d3/%a0, -(%sp)
    ldp 0, %a0, 4
    ldp 1, %d1, 4
    ldp 2, %d2, 4
    move.w #0, %d0
echeck:
    move.l (%a0)+, %d3
    cmp.l %d2, %d3
    bne non_empty

    move.l (%a0)+, %d3
    cmp.l %d2, %d3
    bne non_empty

    move.l (%a0)+, %d3
    cmp.l %d2, %d3
    bne non_empty

    move.l (%a0)+, %d3
    cmp.l %d2, %d3
    bne non_empty

    dbra %d1, echeck

    move.w #1, %d0
non_empty:
    movem.l (%sp)+, %d1-%d3/%a0
    rts


.equ reg_map, 0xA13006
.global mem_test
mem_test:
    movem.l %d1-%d4/%a0, -(%sp)
    move.l #1, %d3
    move.w #0x0f, %d2
    move.l #1, %d0
mem_init:
    move.w %d2, reg_map
    move.w #0xffff, %d1
    move.l #0x100000, %a0
mem_init_loop:
    move.l %d0, (%a0)+
    add.l %d3, %d0
    move.l %d0, (%a0)+
    add.l %d3, %d0
    move.l %d0, (%a0)+
    add.l %d3, %d0
    move.l %d0, (%a0)+
    add.l %d3, %d0
    dbra %d1, mem_init_loop
    add.w #0x10, %d2
    cmp.w #0xff, %d2
    bne mem_init

    move.w #0x0f, %d2
    move.l #1, %d0
    move.w #3, %d4
test_1m_init:
    move.w %d2, reg_map
    move.w #0xffff, %d1
    move.l #0x100000, %a0
test_1m:
    cmp.l (%a0)+, %d0
    bne tst_error
    add.l %d3, %d0

    cmp.l (%a0)+, %d0
    bne tst_error
    add.l %d3, %d0

    cmp.l (%a0)+, %d0
    bne tst_error
    add.l %d3, %d0

    cmp.l (%a0)+, %d0
    bne tst_error
    add.l %d3, %d0


    dbra %d1, test_1m

    sub.l #0x40000, %d0
    dbra %d4, test_1m_init
    move.w #3, %d4
    add.l #0x40000, %d0

    add.w #0x10, %d2
    cmp.w #0xff, %d2
    bne test_1m_init

    move.l #0, %d0
tst_error:
    movem.l (%sp)+, %d1-%d4/%a0
    rts



