
#include "gui.h"


#include "graphics.h"
#include "sega.h"
#include "string.h"
#include "everdrive.h"
#include "rom.h"
#include "mem.h"
#include "os.h"

typedef struct {
    u8 *name;
    u16 state_num;
    u8 **state_name;
} OptionItem;



OptionItem opt[OPT_LEN];


u8 *opt_state_names[OPT_LEN][8] = {

    {"JAP NTSC", "JAP PAL", "US NTSC", "EU PAL", "MULTI"},
    {"OFF", "ON"},
    {"OFF", "ON"},
    {"OS", "MD", "SSF", "CD", "SMS", "MD 10M", "32X"},
    {"SEGA", "CODEMASTERS", "KOREAN", "AUTO"}
};

u16 opt_state_num[OPT_LEN] = {5, 2, 2, 7, 4};

u8 *opt_names[OPT_LEN] = {"MegaKey Region:", "Megakey State:", "In-game Menu:", "Mapper:", "SMS mapper:"};

u16 options() {

    u16 *states = (u16 *) & os_cfg->options;
    //u8 states[OPT_LEN];
    u16 step = 2;
    u16 win_w = 20;
    u16 win_h = OPT_LEN * step + 1;
    u16 win_x = (40 - win_w) / 2;
    u16 win_y = (28 - win_h) / 2 - 1;
    u16 i;
    u16 u;
    u16 str_len;
    u16 max_nlen = 0;
    u16 max_slen = 0;
    u16 max_full_len = 0;
    u16 selector = 0;
    u16 joy_st = 0;
    u16 txt_y;
    u16 txt_x;
    u16 changed = 0;
    u16 resp;


    for (i = 0; i < OPT_LEN; i++) {

        if(states[i] >= opt_state_num[i])states[i] = 0;
        //states[i] = 0;
        //max_slen = 0;
        opt[i].name = opt_names[i];
        opt[i].state_name = opt_state_names[i];
        opt[i].state_num = opt_state_num[i];

        for (u = 0; u < opt[i].state_num; u++) {
            str_len = strLen(opt[i].state_name[u]);
            if (max_slen < str_len)max_slen = str_len;
        }
        str_len = strLen(opt[i].name);
        //str_len += max_slen;
        if (max_nlen < str_len)max_nlen = str_len;

    }

    max_full_len = max_nlen + max_slen;
    //if ((40 - max_full_len) % 2 == 1)max_full_len += 1;
    max_full_len += 1;


    win_x = (40 - max_full_len) / 2 - 1;
    win_w = max_full_len + 2;

    txt_x = (40 - max_full_len) / 2;




    for (;;) {

        gLockRepaint(1);
        guiDrawWin("Options", win_x, win_y, win_w, win_h);
        gSelectPalette(0);
        gSelectPlan(APLAN);
        gLockRepaint(0);


        txt_y = win_y + 1;

        for (i = 0; i < OPT_LEN; i++) {

            if (selector == i)gSelectPalette(2);
            else gSelectPalette(1);
            gDrawString(opt[i].name, txt_x, txt_y);
            gDrawString(opt[i].state_name[states[i]], txt_x + max_nlen + 1, txt_y);

            txt_y += 2;
        }


        while (joy != 0);
        while (joy == 0);
        joy_st = joy;



        if ((joy_st & BUTTON_UP))selector = selector == 0 ? OPT_LEN - 1 : selector - 1;
        if ((joy_st & BUTTON_DOWN))selector++;
        selector %= OPT_LEN;

        if ((joy_st & BUTTON_B)) {
            break;
        }

        if ((joy_st & BUTTON_A)) {
            states[selector]++;
            states[selector] %= opt[selector].state_num;
            changed = 1;
        }

        //break;
    }

    if (changed) {
        resp = osSaveConfig();
        if (resp)return resp;
    }

    return 0;
}
