
.macro ldp  pidx, reg, ris
    move.l (4 + \pidx * 4 + \ris * 4)(%sp), \reg
.endm

.global run_game
run_game:
    ldp 0, %d7, 0
    move.l #0x0, 0xa10008
    move.l #0x0, 0xa1000c
    move.l #0x0, 0xa10010
    move.l #0xff0000, %a1
    move.l #16383, %d0
    move.l #0, %d1
clr_mem:
    move.l %d1, (%a1)+
    dbra %d0, clr_mem

    move.w #0xabab, 0xff8000
    move.l #run_game_code, %a0
    move.l #0xfff000, %a1
    move.l #15, %d0
run_code_copy:
    move.w (%a0)+, (%a1)+
    dbra %d0, run_code_copy
    jmp 0xfff000
run_game_code:
    move.w #0x3210, 0xA13006

    move.w %d7, 0xA13010
    move.w #0, 0xA13000
    
    move.l 0, %a7
    move.l 0x000004, %a0
    jmp (%a0)

.global play_gym
play_gym:
    movem.l %d1-%d4/%a0-%a5, -(%sp)
    move.l #0x100000, %a0
    move.l #0xa04000, %a1
    move.l #0xa04001, %a2
    move.l #0xa04002, %a3
    move.l #0xa04003, %a4
    move.l #0xC00011, %a5

gym_loop:
    move.w joy, %d0
    and.w #0x001c, %d0
    cmp #0, %d0
    bne gym_end

    move.b (%a0)+, %d0

    cmp.b #1, %d0
    beq gym_ym0

    cmp.b #2, %d0
    beq gym_ym1

    cmp.b #3, %d0
    beq gym_psg

    cmp.b #0, %d0
    beq gym_vsync

    cmp.b #0xff, %d0
    bne gym_loop

    bra  gym_end
gym_vsync:
    move.w 0xC00004, %d0
    and.w #1 << 3, %d0
    cmp.w #0, %d0
    bne gym_vsync
gym_vsync1:
    move.w 0xC00004, %d0
    and.w #1 << 3, %d0
    cmp.w #0, %d0
    beq gym_vsync1

    bra gym_pause
    bra gym_loop


gym_ym0:
    move.b (%a0)+, (%a1)
    move.b (%a0)+, (%a2)
    bra gym_pause

gym_ym1:
    move.b (%a0)+, (%a3)
    move.b (%a0)+, (%a4)
    bra gym_pause

gym_psg:
    move.b (%a0)+, (%a5)
    bra gym_pause

gym_pause:
     move.w #17, %d0
gyp:
    dbra %d0, gyp
    bra gym_loop

gym_end:
    movem.l (%sp)+, %d1-%d4/%a0-%a5
    rts



